// Npal.cpp      (C) 2004 adolfo@di-mare.com

#include <iostream>      //  cin && cout
#include <fstream>       //  CIN
// #include "ADH_port.h"

// seleccione uno de EL_MAS_SEGURO -- EL_MAS_SIMPLE -- EL_MENOS_UTIL
#define EL_MAS_SIMPLE

#include "ADH_map.h"

   using namespace ADH; // using namespace ADH;
// using namespace std; // using namespace std;

const int MAX_PALABRA = 255;

int main(int argc, char **argv) {

    map DDD; // El diccionario grandote
    char    str[1+MAX_PALABRA]; // siguiente palabra leida

    std::ifstream CIN("Npal.cpp", std::ios::in);

    #ifdef  EL_MAS_SIMPLE
        // Lee cada palabra y la agrega al diccionario
        while (CIN >> str) {
            Astring palabra = str;
            DDD[palabra]++;        // otro ms...
        }
        /*  NOTA
            Esta versin funciona porque al inicializar pair<Astring, int>
            el constructor de la clase pair<> inicializa cada componente del par
            con el contructor por defecto de la clase el que, apropiadamente,
            para la tipo "int" deja en 0 el campo "second".

            En otras palabras, la siguiente implementacin de pair<> hace que
            ambos campos, "first" y "second", queden inicializados con su
            valor por defecto:
                templates <class T1 , class T2>
                pair<T1,T2>::pair() : first( T1() ), second( T2() ) {}

            Por eso la cuenta de palabras comienza desde 0.
            - Como BC++ v31 no compila la expresin "double()", que significa
              0.0 en C++, si se usa "double" en lugar de "int" el compilador
              BC++ v3.1 no puede compilar este programa.
        */
    #endif
    #ifdef  EL_MAS_EXACTO
        // Lee cada palabra y la agrega al diccionario
        while (CIN >> str) {
            Astring palabra = str;

            map::iterator it = DDD.find(palabra);
            if ( it == DDD.end() ) {         // busca
                DDD.insert( map::value_type (palabra, 1) ); // la agrega si no est
            }
            else { // busca de nuevo "palabra" en "DDD[]"
            //  DDD[palabra]++;         // otro ms...
                (it->second)++;         // feo pero ms eficiente
            }
        }
    #endif
    #ifdef  EL_MENOS_INTELIGENTE
        // Lee cada palabra y la agrega al diccionario
        while (CIN >> str) {
            Astring palabra = str;
            if ( DDD[palabra] == 0 ) {  // como no est...
                DDD[palabra] = 1;       // lo agrega
            }
            else {
                DDD[palabra]++;    // otro ms...
            }
        }
    #endif
    DDD.Ordene(); // Para que salgan en orden las palabras

    std::cout << "ROTULO" << std::endl;

    map::iterator p    = DDD.begin();
    map::iterator endD = DDD.end();

    for ( ; p != endD; ++p) {
        std::cout << '[' << (*p).first.c_str() << ']';
        #ifdef FEO_FEO
            std::cout << " ==> " << (*p).second << std::endl;
        #else
            std::cout << " ==> " <<  p->second  << std::endl;
        #endif
    }

    if (0) {   // demuestra que int() es siempre 0
        int j; double d;
        for ( int i=1; i < 2*2*2*2*2*2*2*2*2*2 ; i*=2 ) {
            j = i; d = double(j);
            assert( j != 0 ); assert ( d != 0.0 );
            j = int(); d = double(j);
            assert( j == 0 ); assert ( d == 0.0 );
        }
        {
            int i;
            double d;
            std::cout << "[int] [double] ==> [" << i << "] [" << d << "] sin inicializar" << std::endl;
            i = int();
            #if (__BORLANDC__ > 0x0410)
                d = double();
            #endif
            std::cout << "[int()] [(double()] ==> [" << i << "] [" << d << ']' << std::endl << std::endl;
        }
    } // double() ==> no compila con BC++ v3.1 <== int() si!!!

    return 0;
}

/*  NOTA:
    Si el archivo a procesar no tiene un rengln en blanco al final,
    la instruccin while (CIN >> str) { ...} falla porque
    Borland C++ v3.1 continua leyendo y nunca termina de agregar
    hileras nulas "".
    - Por eso hay que asegurarse de que el archivo "Npal.cpp"
      tiene un rengln en blanco al final.
*/
// EOF: Npal.cpp
